;-------------------------------
  program='idlharj4_hubble'  & ps=0
;-------------------------------

;use WJ hubble-data in 4point1.dat
;Hubble(1936): recession velocity vs galaxy distance

;varataan tilaa
   d=fltarr(24)
   v=fltarr(24)

;avataan tiedosto laitenumerolle 1
   close,1 & openr,1,'4point1.dat'

;luetaan seliterivit merkiijonoina
   line='' & readf,1,line
   line='' & readf,1,line

;ja dtaa sisaltavat
  for i=0,23 do begin
     readf,1,dd,vv
     d(i)=dd & v(i)=vv
  endfor
  close,1

  psdirect,program+'_0',ps,xsize=16,ysize=8

  plot,d,v,xtitle='etaisyys (MPC)',ytitle='etaantymisnopeus (km/sec)',title='Hubble 1936',psym=6

  psdirect,program+'_0',ps,/stop

;------------------------------------------
;fisher r-test
;parametric test for Pearson correlation coefficient r
;------------------------------------------
; H0: there is no correlation (rho=0)
; H1: there is positive correlation (rho>0)

; testisuure t noudattaa Student'in t-jakaumaa vapausasteella N-2
;       t=r*sqrt((N-2)/(1.-r^2))
; jossa N on otoksen koko
;       r on Pearsonin otoskorrelaatiokerroin

  N=n_elements(d)
  df=N-2
  r=correlate(d,v)*1.d0
  t=r*sqrt((N-2)/(1.-r^2))

;tarkistuksen vuoksi lasketaan r_s suoraan maaritelmasta
  x=d-mean(d)
  y=v-mean(v)
  r_check=total(x*y)/sqrt(total(x^2)*total(y^2))

  print,'-------------------------------------------------'
  print,'Fisher r-testi otoskorrelaatiokertoimelle r_otos:'
  print,'-------------------------------------------------'
  print,'  N= ',N,' r_otos=',r,' tarkistus r=',r_check
  print,'  t=',t
  print,'1-puolinen testi'
  print,'  H0: ei korrelaatiota'
  print,'  H1: positiivinen korrelaatio'
  print,'  prob(r>r_otos|H0)=',1-t_pdf(t,df)
  print,'2-puolinen testi'
  print,'  H0: ei korrelaatiota'
  print,'  H1: positiivinen tai negatiivinen korrelaatio'
  print,'  prob(|r|>|r_otos| |H0)=',2*(1-t_pdf(t,df))
  print,'--------------------------- ----------------------'



  psdirect,program+'_1',ps
  !p.multi=[0,1,2]
  nwin

  x= findgen(1000)/1000.*20-10.
  pdf=gamma((df+1.)/2.)*(1.+x^2/df)^(-(df+1.)/2.)/sqrt(!pi*df)/gamma(df/2.)
  plot,x,pdf,xtitle='t',ytitle='Studentin jakauma pdf',$
       title='1-puolinen tn(r>0.871)= 1.7e-7',/ylog

  ind=where(x ge t)
  xapu=[x(ind),reverse(x(ind))]
  yapu=[pdf(ind)*0,reverse(pdf(ind))]
  polyfill,xapu,yapu
  
  plot,x,pdf,xtitle='t',ytitle='Studentin jakauma pdf',title='2-puolinen tn(|r|>0.871)= 3.4e-7',/ylog
  ind=where(x ge t)
  xapu=[x(ind),reverse(x(ind))]
  yapu=[pdf(ind)*0,reverse(pdf(ind))]
  polyfill,xapu,yapu

  ind=where(x le -t)
  xapu=[x(ind),reverse(x(ind))]
  yapu=[pdf(ind)*0,reverse(pdf(ind))]
  polyfill,xapu,yapu
  psdirect,program+'_1',ps,/stop



;------------------------------------------
;Test Spearman rank-correlation coefficient r_s
;non-parametric test 
;------------------------------------------
; H0: there is no correlation (rho=0)
; H1: there is positive correlation (rho>0)

; testisuure t noudattaa Student'in t-jakaumaa vapausasteella N-2
;       t=r_s*sqrt((N-2)/(1.-r_s^2))
; jossa N on otoksen koko
;       r_s on Spearman'n rank-korrelaatiokerroin

  N=n_elements(d)
  df=N-2
  res=r_correlate(d,v)*1.d0   ; palauttaa r_s  ja prob r_s 2-puolisessa testissa
  r_s=res(0)
  t=r_s*sqrt((N-2)/(1.-r_s^2))

;tarkistuksen vuoksi lasketaan r_s suoraan maaritelmasta
;x=sort(d)+1
;y=sort(v)+1

  x=sort(d)
  y=sort(v)
  x=x-mean(x)
  y=y-mean(y)
  r_s_check1=total(x*y)/sqrt(total(x^2)*total(y^2))
  r_s_check2=1.-6*total((x-y)^2)/(N^3-N)


  print,'-------------------------------------------------'
  print,'Spearman r_s rank-korrelaatiokertoimen testatus'
  print,'-------------------------------------------------'
  print,'  N= ',N,' r_s=',r_s,'  tarkistus:',r_s_check1,r_s_check2
  print,'                        ero tule yhtasuurien arvojen kasittelysta'
  print,'  t=',t
  print,'1-puolinen testi'
  print,'  H0: ei korrelaatiota'
  print,'  H1: positiivinen korrelaatio'
  print,'  prob(r>r_s | H0)=',1-t_pdf(t,df)
  print,'2-puolinen testi'
  print,'  H0: ei korrelaatiota'
  print,'  H1: positiivinen tai negatiivinen korrelaatio'
  print,'  prob(|r|>|r_s| |H0)=',2*(1-t_pdf(t,df))
  print,'
  print,'HUOM: IDL:n r_correlate plauttaa 2-puolisen testin todennakoisyyden'
  print,'res=r_correlate(d,v) --> res=',res
  print,'--------------------------- ----------------------'



;------------------------------------------
;Test Kendall rank-correlation coefficient tau
;non-parametric test 
;------------------------------------------

  print,'Testaa Kendallin rank-korrelaatiokerrointa'
  res=r_correlate(d,v,/kendal)
  print,'res=r_correlate(d,v,/kendal) --> res=',res


!p.multi=0
  psdirect,program+'_2',ps,xsize=16,ysize=8
  nwin
  plot,sort(d)+1,sort(y)+1,xtitle='RANK(d)',ytitle='RANK(v)',title='Hubble 1936',psym=6

  psdirect,program+'_2',ps,/stop


!p.multi=0
end



