  program='idlharj4_outliers'
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Onko ei-parametrisesta mentelmasta apua?
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;luodaan korreloimatonta dataa, jonka joukossa poikkeavia pisteita

  N=25
  M=10000l
  N_out=2

  for icase=1,3 do begin
     if(icase eq 1) then begin
        sig_out=1
        rho_out=0.
        psdirect,program+'_1',ps,/col
        title='Gaussiset X,Y: ei poikkeavia pisteita'
     endif
     if(icase eq 2) then begin
        sig_out=3
        rho_out=0
        psdirect,program+'_2',ps,/col
        title='Gaussiset X,Y + poikkeavia pisteita 10%'
     endif
     if(icase eq 3) then begin
        sig_out=3
        rho_out=0.5
        psdirect,program+'_3',ps,/col
        title='Gaussiset X,Y + poikkeavia korreloituneita pisteita 10%'
     endif

  nwin
  !p.multi=[0,3,2]

  for i=1,3 do begin
     x1=randomn(seed,N-N_out)
     y1=randomn(seed,N-N_out)
     bivariate_gaussian_f,x2,y2,N_out,rho_out,sx=sig_out,sy=sig_out
     x=[x1,x2]
     y=[y1,y2]
     plot,x,y,psym=6,syms=.2,/iso,xr=[-6,6],yr=[-6,6],title='example #'+string(i)
  endfor

  r_tab=fltarr(m)
  rs_tab=fltarr(m)
  for i=0l,m-1 do begin
     x1=randomn(seed,N-N_out)
     y1=randomn(seed,N-N_out)
     bivariate_gaussian_f,x2,y2,N_out,rho_out,sx=sig_out,sy=sig_out
     x=[x1,x2]
     y=[y1,y2]
     r_tab(i)=correlate(x,y)
     res=r_correlate(x,y)
     rs_tab(i)=res(0)
  endfor

  !p.multi=[1,1,2]

nwin

  histo_f,rs_tab,-1,1.2,.05,xt,yt
  plot,xt,yt,psym=10,xtitle='r_otos',ytitle='pdf',col=2,title=title

;teoreettinen jakauma jakaumien transformaatiokaavasta
;kuten edella,paitsi etta N pitaa olla suuri
;f(r)dr = g(t)dt    -->  f(r) = g(t) * dt/dr
;t=r*sqrt(N-2)/sqrt(1-r^2)  -->  dt/dr = sqrt(N-2)/(1-r^2)^1.5
;g(t) =tunnettu Student'n t(df)

  r=findgen(1001)/1001.*2-1
  t=r*sqrt(N-2)/sqrt(1.-r^2)
  g=gamma((df+1.)/2.)*(1.+t^2/df)^(-(df+1.)/2.)/sqrt(!pi*df)/gamma(df/2.)
  dtdr=sqrt(N-2)/(1-r^2)^1.5
  pdf=g*dtdr
  oplot,r,pdf,col=4

  histo_f,r_tab,-1,1.,.05,xt,yt
  oplot,xt,yt,psym=10,col=3,lines=2
  label_data,0.6,.9,['Spearman rs','Pearson r','teoreettine rho=0'],col=[2,3,4],lines=[0,2,0],len=0.075,y_i=0.1

     if(icase eq 1) then begin
        psdirect,program+'_1',ps,/col,/stop
     endif
     if(icase eq 2) then begin
        psdirect,program+'_2',ps,/col,/stop
     endif
     if(icase eq 3) then begin
        psdirect,program+'_3',ps,/col,/stop
     endif
  endfor
endi:
!p.multi=0
end
