
;-------------------------------------------------
 program='idlharj4_test_fisher_pdf' & ps=0
 ;HS 080408
;-------------------------------------------------
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Sama 'kokeellinen' menetelma toimii vaikkei olisikaan rho=0
;   (Fisher-r testi ei pade)
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;luodaan lukupareja x,y jotka noudattavat kaksi-ulotteista
;Gaussista jakaumaa, x ja y riippuvia, korrelaatio rho

;ensin esimerkkejä

psdirect,program+'_esim',ps,/col
!p.multi=[0,2,1]
!p.charsize=0.5
bivariate_gaussian_f,x,y,10000,0.5,/plot
bivariate_gaussian_f,x,y,25,0.5,/plot,psym=6
!p.multi=0
!p.charsize=1
psdirect,program+'_esim',ps,/col,/stop


psdirect,program,ps,/col

!p.multi=[0,1,2]  

  N=25
  M=50000l
  rho=.5
  nwin
  r_tab=fltarr(m)
  for i=0l,m-1 do begin   
     bivariate_gaussian_f,x,y,N,rho
     r_tab(i)=correlate(x,y)
  endfor

;------------------------------------------------------------------
;Esimerkki: mika on todennakoisyys etta otoskorrelaatio > 0.6
; kun todellinen korrelaatio rho= 0.5
; Arvioidaan eo. kokeiden perusteella 
  ind=where(r_tab gt 0.6,count)
  print,'--------------------------------------'
  print,'Suureiden todellinen korrelaatio rho=',rho
  print,'--------------------------------------'
  print,'kokeilun perusteella r> 0.6 todennakoisyys=',1.*count/M  


;-------------------------------------------------------
;jakauma
  histo_f,r_tab,-1,1,.05,xt,yt
  plot,xt,yt,psym=10,xtitle='r_otos',ytitle='pdf(r_otos)',yr=[0,5],$
       title='otoskorrelaatioiden r jakauma rho='+string(rho)+'   N='+string(N)

;Vaikka Fisgerin r-testi soveltuu vain tapaukselle rho=0,
;luennolla on annettu pdf mielivaltaiselle rho:n arvolle
; Fisher (1944) pdf(r|rho)
  
  r=findgen(1001)/1000.*2.-1.
  prob_r=(1.d0-rho^2)^(N/2.d0-0.5d0)*(1-r^2)^(N/2.d0-2.d0)/$
         (1.d0-rho*r)^(N-1.5d0)*(1.d0+1.d0/(N-0.5d0)*(1.d0+r*rho)/8.d0)
;normeerataan 
  prob_r=prob_r/(mean(prob_r)*2.)
  oplot,r,prob_r,col=3

;muodostetaan teoreettinen arvio r>0.6
  ind=where(r gt 0.6)
  print,'Fisher-jakauman perusteella r> 0.6 todennakoisyys=',$
        total(prob_r(ind))/total(prob_r)


;-----------------------------------------------------------------
;Entapa jos x ja y eivat olekaan gaussisesti jakaantuneita?
;bivariate_gaussian_f,/uni  -> korreloituneita lukuja tasaisesta jakaumasta
;-----------------------------------------------------------------
  
  for i=0l,m-1 do begin   
     bivariate_gaussian_f,x,y,N,rho,uni=1
     r_tab(i)=correlate(x,y)
  endfor


  histo_f,r_tab,-1,1,.05,xt,yt
  plot,xt,yt,psym=10,xtitle='r_otos',ytitle='pdf(r_otos)',yr=[0,5],$
       title='X ja Y tasaisesta jakaumasta Gaussin-jakauman sijaan'
  oplot,r,prob_r,col=3


  ind=where(r_tab gt 0.6,count)
  print,'--------------------------------------'
  print,'Tasainen jakauma Gaussisen jakauman sijaan:'
  print,'kokeilun perusteella r> 0.6 todennakoisyys=',1.*count/M  



psdirect,program,ps,/col,/stop
!p.multi=0
end
