;-------------------------------------------------
 program='idlharj4_test_fisher_rtest' & ps=0
 ;HS 080408
;-------------------------------------------------

;++++++++++++++++++++++++++++++++++++
;testataan Fisher-r testia
;++++++++++++++++++++++++++++++++++++
;luodaan M kappaletta N:n riippumattoman  X,Y lukuparin otoksia
;lasketaan kullekin M otoskorrelaatiokerroin --> taulukko r_tab(M)
;verrataan havaittua jakaumaa teoreettiseen

  N=25
  M=50000l
  r_tab=fltarr(m)
  for i=0l,m-1 do begin
     x=randomn(seed,N)
     y=randomn(seed,N)

;kokeile onko vaikutusta
;     x=randomu(seed,N)
;     y=randomu(seed,N)

     r_tab(i)=correlate(x,y)
  endfor

;------------------------------------------------------------------
;a) Esimerkki: mika on todennakoisyys etta otoskorrelaatio > 0.1
;(vaikkei todellista korrelaatiota olekaan) ?

; Arvioidaan eo. kokeiden perusteella 
  ind=where(r_tab gt 0.1,count)
  print,'--------------------------------------'
  print,'Suureiden todellinen korrelaatio rho=0'
  print,'pisteparien lkm N=',N,' muodostetaan kaikkiaan M=',M,' otosta'
  print,'--------------------------------------'
  print,'kokeilun perusteella r> 0.1 todennakoisyys=',1.*count/M  

;teoreettinen
  r=0.1
  df=N-2
  t=r*sqrt(N-2)/sqrt(1.-r^2)
  print,'t-jakaumasta teoreettinen todennkoisyys: ', 1.-t_pdf(t,df)


;-------------------------------------------------------------------
; b) verrataan yhden r-arvon sijasta jakaumia kokonaisuudessaan


  psdirect,program,ps,/col
  !p.multi=[0,1,2]
  nwin

;----------------------
;Muodostetaan havaittu jakauma testisuureelle 
; t=r*sqrt(N-2)/sqrt(1-r^2) 

  t_tab=r_tab*sqrt(N-2)/sqrt(1.-r_tab^2)
  histo_f,t_tab,-5,5,.1,xt,yt
  plot,xt,yt,psym=10,xtitle='t_otos',ytitle='pdf(t_otos)',$
       title='otos testisuureiden t jakauma (rho=0), N='+string(N)

;Teoreettinen jakauma = Studentin jakauma vapausasteella df=N-2

  df=N-2.d0
  x=findgen(10001)/1001.*2-5
  pdf=gamma((df+1.)/2.)*(1.+x^2/df)^(-(df+1.)/2.)/sqrt(!pi*df)/gamma(df/2.)
  oplot,x,pdf,col=2

;------------------------
;plotataan suoraan havaittu r_otos-jakauma:

  histo_f,r_tab,-1,1,.05,xt,yt
  plot,xt,yt,psym=10,xtitle='r_otos',ytitle='pdf(r_otos)',$
       title='otoskorrelaatioiden r jakauma (rho=0), N='+string(N)
;teoreettinen jakauma jakaumien transformaatiokaavasta
;f(r)dr = g(t)dt    -->  f(r) = g(t) * dt/dr
;Nyt
;t=r*sqrt(N-2)/sqrt(1-r^2)  -->  dt/dr = sqrt(N-2)/(1-r^2)^1.5
;g(t) =tunnettu Student'n t(df)

  r=findgen(1001)/1001.*2-1
  t=r*sqrt(N-2)/sqrt(1.-r^2)
  g=gamma((df+1.)/2.)*(1.+t^2/df)^(-(df+1.)/2.)/sqrt(!pi*df)/gamma(df/2.)
  dtdr=sqrt(N-2)/(1-r^2)^1.5
  pdf=g*dtdr
  oplot,r,pdf,col=2

psdirect,program,ps,/col,/stop
end
